unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, GLScene, GLObjects, GLTeapot, GLCoordinates, GLCrossPlatform,
  BaseClasses, GLWin32Viewer, GLSkydome, ExtCtrls, StdCtrls, GLGeomObjects,
  GLPolyhedron, GLColor;

type
  TForm1 = class(TForm)
    GLSceneViewer1: TGLSceneViewer;
    GLScene1: TGLScene;
    GLCamera1: TGLCamera;
    GLLightSource1: TGLLightSource;
    GLTeapot1: TGLTeapot;
    GLPlane1: TGLPlane;
    GLDummyCube1: TGLDummyCube;
    GLLightSource2: TGLLightSource;
    GLSkyDome1: TGLSkyDome;
    GLSphere1: TGLSphere;
    Timer1: TTimer;
    Button1: TButton;
    Label1: TLabel;
    Timer2: TTimer;
    Label2: TLabel;
    Button2: TButton;
    GLCylinder1: TGLCylinder;
    Timer3: TTimer;
    Label3: TLabel;
    Button3: TButton;
    GLDodecahedron1: TGLDodecahedron;
    Timer4: TTimer;
    procedure GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure GLSceneViewer1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer2Timer(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Timer3Timer(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Timer4Timer(Sender: TObject);
    procedure FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
    procedure FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
      MousePos: TPoint; var Handled: Boolean);
  private
    { Private declarations }
    px,py     : integer;
    xx, dxx   : single;
    th, dth   : single;
    ecy, decy : single;
    ss        : single;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  xx   := 0.0;
  dxx  := 3.0/25;

  th   := 0;
  dth  := 360/40;

  ecy  := 1.0;
  decy := 1.5/20;

  ss := GLCamera1.SceneScale;
end;

procedure TForm1.FormMouseWheelDown(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  ss := ss - 0.01;
  if (ss <= 0.2) then ss := 0.2;
  GLCamera1.SceneScale := ss;
end;

procedure TForm1.FormMouseWheelUp(Sender: TObject; Shift: TShiftState;
  MousePos: TPoint; var Handled: Boolean);
begin
  ss := ss + 0.01;
  if (ss > 2.5) then ss := 2.5;
  GLCamera1.SceneScale := ss;
end;

procedure TForm1.GLSceneViewer1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  px := X;
  py := Y;
end;

procedure TForm1.GLSceneViewer1MouseMove(
  Sender: TObject;
  Shift: TShiftState;
  X, Y: Integer);
begin
  if ssLeft in Shift then begin
    GLCamera1.MoveAroundTarget(py-Y,px-X);
    px := X;
    py := Y;
  end;
end;

// Codigo del hilo (reloj) control de traslacion de la esfera
procedure TForm1.Timer1Timer(Sender: TObject);
begin
  xx := xx + dxx;
  GLSphere1.Position.X := xx;

  if xx >=  1.5 then dxx := -dxx;
  if xx <= -1.5 then dxx := -dxx;
end;

// activa y desactiva Timer1
procedure TForm1.Button1Click(Sender: TObject);
begin
  if Button1.Caption = '>>'
    then begin
      Button1.Caption := '||';
      Timer1.Enabled := true;
    end
    else begin
      Button1.Caption := '>>';
      Timer1.Enabled := false;
    end;
end;

// codigo del hilo (reloj) control de rotacion de la Tetera
procedure TForm1.Timer2Timer(Sender: TObject);
begin
  th := th + dth;
  GLteapot1.TurnAngle := th;

  if th >=  360 then dth := -dth;
  if th <=  0   then dth := -dth;

end;

// activa y desactiva al Timer2
procedure TForm1.Button2Click(Sender: TObject);
begin
  if Button2.Caption = '>>'
    then begin
      Button2.Caption := '||';
      Timer2.Enabled := true;
    end
    else begin
      Button2.Caption := '>>';
      Timer2.Enabled := false;
    end;
end;

// Animacion del cilindro, cambiando su escala
procedure TForm1.Timer3Timer(Sender: TObject);
var
  h : single;
begin
  ecy := ecy + decy;
  GLCylinder1.Scale.Y := ecy;

  if ecy >=  2.0 then decy := -decy;
  if ecy <=  0.5 then decy := -decy;

  h := ecy/2;

  GLCylinder1.Position.Z := h;

end;

// activa y desactiva control del cilindro
procedure TForm1.Button3Click(Sender: TObject);
begin
  if Button3.Caption = '>>'
    then begin
      Button3.Caption := '||';
      Timer3.Enabled := true;
    end
    else begin
      Button3.Caption := '>>';
      Timer3.Enabled := false;
    end;
end;

// cambia de color al dodecahedro
procedure TForm1.Timer4Timer(Sender: TObject);
begin
  with GLDodecahedron1.Material.FrontProperties do
    if (Emission.Color[0] = clrBronze[0]) and
       (Emission.Color[1] = clrBronze[1]) and
       (Emission.Color[2] = clrBronze[2])
      then Emission.Color := clrDarkOrchid
      else Emission.Color := clrBronze;

end;




end.
